add devbyid dependency
[automated-distro-installer] / pxe-server
index 1f75adb61ebb3a443ae7a2e4e7029adc3a728991..9c3f917fcaceee7a488453759aa6eed44b528250 100755 (executable)
@@ -28,60 +28,65 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 usage() {
     cat <<EOF
-Usage: ${0##*/} [OPTIONS] TYPE [HOST]
+Usage: ${0##*/} [OPTIONS] [HOST TYPE]
 One line description
 
-TYPE is one of arch, plain, fai, or : for no pxe server.
-HOST makes the pxe server only for that specific host
-
+TYPE is one of arch, plain, fai.
+HOST is a hostname known to the dhcp server, or default for all, or none to disable
+
+-r         Don't redeploy fai config. For example, if there is a different host
+           that is mid-install.
+-a         Wait for 2 dhcp acks, then disable the pxe server after a delay.
+           First ack is for pxe boot, 2nd ack is for os boot. Sometimes
+           on debian, there is a 3rd one shortly after the 2nd. I can't remember
+           exactly why this caused a problem, but I'm hoping the sleep
+           will take care of it.
+-w         Initially setup pxe, then wait like -a.
 -h|--help  Print help and exit
---         Subsequent arguments are never treated as options
--p         Persist. Otherwise, wait for dhcp acks then remove.
--r         Don't redeploy fai config.
--a         Wait for 2 dhcp acks instead of the default 3. Some distros
-           do 2, some do 3.
+
+
+Note: Uses GNU getopt options parsing style
 EOF
     exit $1
 }
 
 ##### begin command line parsing ########
 
-persist=false
 args=()
 redep=true
-acks=3
-while [[ $1 ]]; do
+acks=2
+wait=false
+temp=$(getopt -l help harw "$@") || usage 1
+eval set -- "$temp"
+while true; do
     case $1 in
-        --) shift; break ;;
-        -h|--help) usage ;;
+        -a) wait=true; set=false; shift ;;
         -r) redep=false; shift ;;
-        -p) persist=true; shift ;;
-        -a) acks=2; shift ;;
-        *) args+=("$1"); shift ;;
+        -w) wait=true; set=true; shift ;;
+        -h|--help) usage ;;
+        --) shift; break ;;
+        *) echo "$0: Internal error!" ; exit 1 ;;
     esac
 done
-args+=("$@")
-
 
-read type host <<<"${args[@]}"
+read host type <<<"$@"
 
-if [[ ! $type ]]; then
-    echo "$0: error: exptected 1 argument of type"
-    usage 1
-fi
+case $# in
+    0|2);;
+    *)
+        echo "$0: error: expected 0 or 2 arguments"
+        echo
+        usage 1
+        ;;
+esac
 
 if [[ $host ]]; then
     host_tag="tag:$host,"
 fi
 
-case $type in
-    :|true) persist=true ;;
-    arch) acks=2 ;;
-esac
-
 ##### end command line parsing ########
 
-sv() {
+e() {
     echo "$@"
     "$@"
 }
@@ -105,7 +110,7 @@ EOF
 fai() {
     cat <<EOF
 $set_host_tag
-dhcp-boot=${host_tag}fai/pxelinux.0,faiserver.lan,faiserver.lan
+dhcp-boot=${host_tag}pxelinux.0,faiserver.lan,faiserver.lan
 EOF
 }
 
@@ -123,36 +128,45 @@ ack-wait() {
             echo $line
         fi
     done < <(ssh wrt logread -f)
-    sv sleep 5
+    e sleep 20
 }
 
 set-pxe() {
-    ${1:-$type} | ssh wrt "cedit pxe-server /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
-if [[ $type == arch ]]; then arch-pxe-mount; fi"
+    ${type:-:}|ssh wrt "cedit pxe /etc/dnsmasq.conf || /etc/init.d/dnsmasq restart
+$([[ $type == arch ]] && echo arch-pxe-mount)"
 }
 
-set-pxe
 
-if [[ $type == fai ]]; then
-    if $redep; then
-        fai-redep
+if $set; then
+    set-pxe
+    if [[ $type == fai ]]; then
+        e myfai-chboot $host
+        if $redep; then
+            e fai-redep
+        fi
+    else
+        e myfai-chboot
     fi
-    faiserver-enable
 fi
 
-if ! $persist; then
+if $wait; then
     # fai's debian jessie 8.5ish does 2 dhcp requests when booting,
     # roughly 4 seconds apart. Earlier
     # versions did just 1. Now testing on a vm, it does 1.
     # bleh.
     echo "waiting for $acks dhcp acks then disabling pxe"
     ack-wait $acks
-    set-pxe :
-    if [[ $type == fai ]]; then
-        # fai server can contain sensitive info, so turn it off
-        # when it's not in use.
-        echo "waiting for 1 dhcp ack then disabling fai server"
-        ack-wait 1
-        faiserver-disable
-    fi
+    type=
+    set-pxe
+
+    # previously tried waiting for one more ack then disabling faiserver,
+    # since it can contain sensitive info, so turn it off when not in use,
+    # but disabling that for now as it's inconvenient to clean this
+    # up and run it in the background etc.
+
+    # if [[ $type == fai ]]; then
+    #     echo "waiting for 1 dhcp ack then disabling fai server"
+    #     ack-wait 1
+    #     faiserver-disable
+    # fi
 fi